window.onload = function () {

    /* ******************** Настройки служебные ******************** */
    // SwitchRoom("room_preloader");
    // SwitchRoom('room_afterpreloader');

    // Массив событий для комнат и интерфейса
    var ticks = [];
    ticks["room_interface"] = new CustomEvent("room_interface");

    var curTime = new Date().getTime();
    var diffTickTime = 0;
    var FPS = 0;
    var startFPStime = curTime;

    // Заполняем ассациативный массив событиями
    for (var i = 0, len = rooms.length; i < len; i++) {
        ticks[ rooms[i] ] = new CustomEvent(rooms[i]);
    }

    var tmrGlobal = window.document.getElementById("tmr_global");
    var intervalTick = setInterval(function () {
        var newTime = new Date().getTime();
        diffTickTime = (newTime - curTime);
        curTime = newTime;

        if ( (curTime - startFPStime) >= 1000 ) {
            startFPStime = curTime;
            // ObjSet('txt_bottle_fps', { text: 'FPS: ' +FPS });
            FPS = 0;
        } else {
            FPS++;
        }

        ticks[currentRoom]['diffMs'] = diffTickTime;
        ticks["room_interface"].diffMs = diffTickTime;
        tmrGlobal.dispatchEvent(ticks[currentRoom]);
        tmrGlobal.dispatchEvent(ticks["room_interface"]);



        // Отключение логотипа порнгеймс в нужных комнатах
        var roomsDisableLogo = ['room_preloader', 'room_win', 'room_gameover'];
        var blockLogo = false;
        roomsDisableLogo.forEach(function(element) {
            if (element == currentRoom) {
                blockLogo = true;
            }

            if (blockLogo) {
                setLogoPornGames(0);
            } else {
                setLogoPornGames(1);
            }
        });
    }, 20);

    function randomInteger(min, max) {
        var rand = min - 0.5 + Math.random() * (max - min + 1)
        rand = Math.round(rand);
        return rand;
    }

    /* ******************** Глобальные переменные ******************** */
    doneSpeeds = [];
    var timer;
    var position = 'classic';
    var currentSpeedVideo = 'slow';
    var needSpeedVideo;
    var doneSpeeds = [];
    var availSpeeds = ['slow', 'fast', 'furious'];
    var nameVideo = '';
    var isChangeSpeed = false;
    var isVideoCum = false;
    var currentVideo = '';

    /* ******************** Во весь экран ******************** */
    var isFullScreen = function() {
        return document.webkitIsFullScreen || document.mozFullScreen || document.msFullscreenElement;
    }
    window.addEventListener('resize', () => {
        if ( isFullScreen() ) {
            var zoomRateW = (window.innerWidth / 1200);
            var zoomRateH = (window.innerHeight / 1000);
            var rate = (zoomRateW < zoomRateH) ? zoomRateW : zoomRateH;
            // console.log('zoomRateW', zoomRateW);
            // console.log('zoomRateH', zoomRateH);
            // console.log('rate', rate);

            // htmlGame.style="zoom: " + rate +  "; overflow: hidden;";
            // htmlGame.style="transform: scaleX(" + rate + ") scaleY(" + rate + "); float: left; overflow: hidden;";
            gameArea.style="transform: scale(" + rate + "); float: left;";
        } else {
            gameArea.style="transform: scale(0.677); float: left;";
            // gameArea.style="transform: scale(0.67); float: left; float: left; overflow: hidden;";
            // htmlGame.style="transform: scaleX(0.67) scaleY(0.67); float: left; overflow: hidden;";
            // htmlGame.style="zoom: 0.67; overflow: hidden;";
        }

    });

    function toggleFullScreen() {
        var doc = window.document;
        var docEl = doc.documentElement;
      
        var requestFullScreen = docEl.requestFullscreen || docEl.mozRequestFullScreen || docEl.webkitRequestFullScreen || docEl.msRequestFullscreen;
        var cancelFullScreen = doc.exitFullscreen || doc.mozCancelFullScreen || doc.webkitExitFullscreen || doc.msExitFullscreen;
        if(!doc.fullscreenElement && !doc.mozFullScreenElement && !doc.webkitFullscreenElement && !doc.msFullscreenElement) {
            requestFullScreen.call(docEl);
        } else {
            cancelFullScreen.call(doc);
            gameArea.style="transform: scale(0.677); float: left;";
        }
    }

    ObjSet('spr_interface_full_screen', {
        event_mup: function() {
            toggleFullScreen();
        },
        event_menter: function() {
            ObjSet('spr_interface_full_screen', { scale_x: 1, scale_y: 1 });
        },
        event_mleave: function() {
            ObjSet('spr_interface_full_screen', { scale_x: 0.8, scale_y: 0.8 });
        }
    });

    /* ******************** Диалоги ******************** */
    var currentDialog = 0;
    var dialogs = {
        "1": {
            image: '',
            x: 47,
            y: 276,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "2": {
            image: '',
            x: 646,
            y: 332,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "3": {
            image: '',
            x: 47,
            y: 276,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "4": {
            image: '',
            x: 646,
            y: 332,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "5": {
            image: '',
            x: 47,
            y: 276,
            next: false,
            open: function() {
            },
            close: function() {
                startSexScene('bruce_wayne');
            }
        },
        "6": {
            image: '',
            x: 752,
            y: 276,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "7": {
            image: '',
            x: 76,
            y: 260,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "8": {
            image: '',
            x: 0,
            y: 0,
            next: true,
            open: function() {
                playVideo('video_alfred');
            },
            close: function() {
            }
        },
        "9": {
            image: '',
            x: 76,
            y: 260,
            next: true,
            open: function() {
                playVideo('video_bruce_wayne_after_sex');
            },
            close: function() {
            }
        },
        "10": {
            image: '',
            x: 752,
            y: 276,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "11": {
            image: '',
            x: 76,
            y: 260,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "12": {
            image: '',
            x: 0,
            y: 0,
            next: false,
            open: function() {
                playVideo('video_alfred_surprised');
            },
            close: function() {
                startSexScene('alfred');
            }
        },
        "13": {
            image: '',
            x: 420,
            y: 214,
            next: true,
            open: function() {
                ObjSet('spr_video_chapter1', { alp: 1 });
                ObjSet('spr_video_chapter2', { alp: 1 });
                ObjSet('spr_video_chapter3', { alp: 1 });
            },
            close: function() {
            }
        },
        "14": {
            image: '',
            x: 420,
            y: 214,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "15": {
            image: '',
            x: 420,
            y: 214,
            next: false,
            open: function() {
            },
            close: function() {
                ObjSet('spr_video_chapter1', { alp: 1, input: 1, 
                    event_mup: function() {
                        playVideo('video_batmobile');
                        ObjSet('spr_video_play', { input: 1, alp: 1 });
                        ObjSet('spr_video_chapter1', { input: 0, alp: 0 });
                        ObjSet('spr_video_chapter2', { input: 0, alp: 0 });
                        ObjSet('spr_video_chapter3', { input: 0, alp: 0 });
                    }
                });
            }
        },
        "16": {
            image: '',
            x: 420,
            y: 171,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "17": {
            image: '',
            x: 572,
            y: 612,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "18": {
            image: '',
            x: 420,
            y: 150,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "19": {
            image: '',
            x: 572,
            y: 612,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "20": {
            image: '',
            x: 420,
            y: 150,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "21": {
            image: '',
            x: 572,
            y: 612,
            next: false,
            open: function() {
            },
            close: function() {
                playVideo('video_batmobile');
                ObjSet('spr_video_play', { input: 1, alp: 1 });
            }
        },
        "22": {
            image: '',
            x: 626,
            y: 672,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "23": {
            image: '',
            x: 626,
            y: 672,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "24": {
            image: '',
            x: 626,
            y: 672,
            next: false,
            open: function() {
            },
            close: function() {
                ObjSet('spr_video_play', { input: 1, alp: 1 });
            }
        },
        "25": {
            image: '',
            x: 243,
            y: 234,
            next: true,
            open: function() {
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            },
            close: function() {
            }
        },
        "26": {
            image: '',
            x: 624,
            y: 600,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "27": {
            image: '',
            x: 243,
            y: 234,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "28": {
            image: '',
            x: 624,
            y: 600,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "29": {
            image: '',
            x: 243,
            y: 234,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "30": {
            image: '',
            x: 624,
            y: 600,
            next: false,
            open: function() {
            },
            close: function() {
                startSexScene('poison_ivy');
            }
        },
        "31": {
            image: '',
            x: 0,
            y: 0,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "32": {
            image: '',
            x: 624,
            y: 600,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "33": {
            image: '',
            x: 0,
            y: 0,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "34": {
            image: '',
            x: 624,
            y: 600,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "35": {
            image: '',
            x: 0,
            y: 0,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "36": {
            image: '',
            x: 624,
            y: 600,
            next: false,
            open: function() {
            },
            close: function() {
                playVideo('video_batmobile');
                ObjSet('spr_video_play', { input: 1, alp: 1 });
            }
        },
        "37": {
            image: '',
            x: 569,
            y: 676,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "38": {
            image: '',
            x: 569,
            y: 676,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "39": {
            image: '',
            x: 569,
            y: 676,
            next: false,
            open: function() {
            },
            close: function() {
                ObjSet('spr_video_play', { input: 1, alp: 1 });
            }
        },
        "40": {
            image: '',
            x: 0,
            y: 0,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "41": {
            image: '',
            x: 569,
            y: 620,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "42": {
            image: '',
            x: 0,
            y: 0,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "43": {
            image: '',
            x: 569,
            y: 620,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "44": {
            image: '',
            x: 0,
            y: 0,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "45": {
            image: '',
            x: 569,
            y: 620,
            next: false,
            open: function() {
            },
            close: function() {
                startSexScene('red_claw');
            }
        },
        "46": {
            image: '',
            x: 0,
            y: 0,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "47": {
            image: '',
            x: 569,
            y: 620,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "48": {
            image: '',
            x: 0,
            y: 0,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "49": {
            image: '',
            x: 569,
            y: 620,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "50": {
            image: '',
            x: 0,
            y: 0,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "51": {
            image: '',
            x: 569,
            y: 620,
            next: false,
            open: function() {
            },
            close: function() {
                playVideo('video_batmobile');
                ObjSet('spr_video_play', { input: 1, alp: 1 });
            }
        },
        "52": {
            image: '',
            x: 569,
            y: 676,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "53": {
            image: '',
            x: 569,
            y: 676,
            next: true,
            open: function() {
            },
            close: function() {
            }
        },
        "54": {
            image: '',
            x: 569,
            y: 676,
            next: false,
            open: function() {
            },
            close: function() {
                ObjSet('spr_video_play', { input: 1, alp: 1 });
                // showDialog();
            }
        },
        "55": {
            image: '',
            x: 420,
            y: 150,
            next: true,
            open: function() {
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            },
            close: function() {
            }
        },
        "56": {
            image: '',
            x: 569,
            y: 620,
            next: true,
            open: function() {
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            },
            close: function() {
            }
        },
        "57": {
            image: '',
            x: 420,
            y: 150,
            next: true,
            open: function() {
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            },
            close: function() {
            }
        },
        "58": {
            image: '',
            x: 569,
            y: 620,
            next: true,
            open: function() {
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            },
            close: function() {
            }
        },
        "59": {
            image: '',
            x: 420,
            y: 150,
            next: true,
            open: function() {
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            },
            close: function() {
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            }
        },
        "60": {
            image: '',
            x: 569,
            y: 620,
            next: false,
            open: function() {
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            },
            close: function() {
                startSexScene('harley_quinn');
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            }
        },
        "61": {
            image: '',
            x: 420,
            y: 200,
            next: true,
            open: function() {
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            },
            close: function() {
                winGame();
            }
        }
    };

    function setLoading(active) {
        ObjSet('spr_interface_loading', { input: active });
        ObjAnimate('spr_interface_loading', 'alp', 0, 0, function() { }, [ 0,0,'cur', 0.5,0,active ]);
    }

    var defaultPosDialog = {
        pos_x: 420,
        pos_y: 150
    }
    function hideDialog() {
        ObjSet('spr_interface_dialog', { res: '', pos_x: defaultPosDialog.pos_x, pos_y: defaultPosDialog.pos_y, input: 0, alp: 0 });
    }

    showDialog = function(numDialog) {
        currentDialog++;

        if (numDialog) {
            currentDialog = numDialog;
        }

        if (dialogs[currentDialog]) {
            // console.log('dialog', currentDialog, '=', dialogs[currentDialog].open);
            var posX = dialogs[currentDialog].x || defaultPosDialog.pos_x;
            var posY = dialogs[currentDialog].y || defaultPosDialog.pos_y;
            var image = (dialogs[currentDialog].image || currentDialog);

            ObjSet('spr_interface_dialog', { res: 'images/dialogs/' + image + '.png', pos_x: posX, pos_y: posY, alp: 0.7, input: 1,
                event_mup: function() {
                    if (dialogs[currentDialog].close) {
                        dialogs[currentDialog].close();
                    }
                    if (dialogs[currentDialog].next) {
                        showDialog();
                    } else {
                        hideDialog();
                    }
                    
                }
            });

            if (dialogs[currentDialog].open) {
                dialogs[currentDialog].open();
            }
        } else {
            hideDialog();
        }
    }
    // showDialog();
    /* ******************** Прелоадер ******************** */
    // video_preloader_start.oncanplay = function() {
        // console.log('start');
    // }
    ObjSet('spr_interface_porn_games', {
        event_mup: function() {
            window.open('http://www.porngames.com/');
        },
        event_menter: function() {
            ObjSet('spr_interface_porn_games', { scale_x: 1.5, scale_y: 1.5 });
        },
        event_mleave: function() {
            ObjSet('spr_interface_porn_games', { scale_x: 1.3, scale_y: 1.3 });
        }
    });

    setLogoPornGames = function(active) {
        ObjSet('spr_interface_porn_games', { input: active, alp: active });
    }

    ObjSet('video_preloader_start', {
        event_mup: function() {
            window.open('http://www.porngames.com/');
        }
    });
    ObjSet('video_preloader_end', {
        event_mup: function() {
            window.open('http://www.porngames.com/');
        }
    });

    var videoPreloaderStart = document.getElementById('video_preloader_start');
    var videoPreloaderEnd = document.getElementById('video_preloader_end');

    ObjSet('spr_preloader_continue', {
        event_mup: function() {
            ObjSet('spr_preloader_continue', { input: 0 });
            
            ObjSet('video_preloader_end', { alp: 1 });
            ObjSet('video_preloader_start', { alp: 0 });
            
            videoPreloaderStart.pause();
            videoPreloaderEnd.play();

            // videoPreloaderEnd.oncanplay = function() {
            //     videoPreloaderEnd.play();
            // };
            
            videoPreloaderEnd.onended = function() {
            videoPreloaderStart.pause();
            videoPreloaderEnd.pause();
            playVideo('video_batman_menu');
                ObjSet('spr_interface_full_screen', { input: 1, alp: 0.5 });
            };
        }
    });

    /* ******************** Код игры ******************** */
    /* ******************** after preloader ******************** */
    ObjSet('spr_afterpreloader_play', { alp: 1, input: 1 });

    ObjSet('spr_afterpreloader_play', { 
        event_mup: function() {
            ObjSet('spr_afterpreloader_play', { alp: 0, input: 0 });
            ObjSet('spr_afterpreloader_presents', { alp: 0, input: 0 });
            SwitchRoom('room_intro');
        }
    });

    /* ******************** intro ******************** */
    ObjSet('spr_intro_play', { alp: 1, input: 1 });

    ObjSet('spr_intro_play', { 
        event_mup: function() {
            ObjSet('spr_intro_play', { alp: 0, input: 0 });
            ObjSet('spr_intro_presents', { alp: 0, input: 0 });
            SwitchRoom('room_1room');
        }
    });

    /* ******************** 1 room ******************** */

    ObjSet('spr_1room_arrow', { 
        event_mup: function() {
            SwitchRoom('room_intro');
        }
    });
    ObjSet('spr_1room_arrow2', { 
        event_mup: function() {
            SwitchRoom('room_2room');
        }
    });

    /* ******************** 2 room ******************** */
    ObjSet('spr_2room_arrow', { 
        event_mup: function() {
            SwitchRoom('room_1room');
        }
    });
    ObjSet('spr_2room_arrow2', { 
        event_mup: function() {
            SwitchRoom('room_3room');
        }
    });

    /* ******************** 3 room ******************** */
    ObjSet('spr_3room_arrow', { 
        event_mup: function() {
            SwitchRoom('room_2room');
        }
    });
    ObjSet('spr_3room_arrow2', { 
        event_mup: function() {
            SwitchRoom('room_4room');
        }
    });

    /* ******************** 4 room ******************** */
    ObjSet('spr_4room_arrow', { 
        event_mup: function() {
            SwitchRoom('room_3room');
        }
    });
    ObjSet('spr_4room_arrow2', { 
        event_mup: function() {
            SwitchRoom('room_5room');
        }
    });

    /* ******************** 5 room ******************** */
    ObjSet('spr_5room_arrow', { 
        event_mup: function() {
            SwitchRoom('room_4room');
        }
    });
    ObjSet('spr_5room_arrow2', { 
        event_mup: function() {
            SwitchRoom('room_6room');
        }
    });

    /* ******************** 6 room ******************** */
    ObjSet('spr_6room_arrow', { 
        event_mup: function() {
            SwitchRoom('room_5room');
        }
    });
    ObjSet('spr_6room_arrow2', { 
        event_mup: function() {
            SwitchRoom('room_7room');
        }
    });

    /* ******************** 7 room ******************** */
    ObjSet('spr_7room_arrow', { 
        event_mup: function() {
            SwitchRoom('room_6room');
        }
    });
    ObjSet('spr_7room_arrow2', { 
        event_mup: function() {
            // SwitchRoom('room_bottle');
            startSexScene('alfred');
        }
    });
    /* ******************** room video ******************** */
    // ObjSet('spr_video_back', { 
    //     event_mup: function() {
    //         SwitchRoom('room_win');
    //     }
    // });

    var videoBatmobile = 0;
    var videoGordon = 0;

    ObjSet('spr_video_play', { 
        event_mup: function() {
            // console.log('nameVideo', currentVideo)

            if (currentDialog == 24) {
                playVideo('video_poison_ivy'); // 24
                showDialog();
            } else if (currentDialog == 54) {
                playVideo('video_harley_quinn'); // 54
                showDialog();
            }

            if (currentVideo == 'video_batman_menu') {
                playVideo('spr_video_bg_manor');
            } else if (currentVideo == 'spr_video_bg_manor') {
                playVideo('video_bruce_wayne');
                showDialog();
                ObjSet('spr_video_play', { input: 0, alp: 0 });
            } else if (currentVideo == 'spr_video_bg_store') {
                playVideo('video_red_claw');
                ObjSet('spr_video_play', { input: 0, alp: 0 });
                showDialog();
            } else if (currentVideo == 'video_batmobile') {
                StopSound("sounds/env_sex.mp3", 0);
                StopSound("sounds/env_dangerous.mp3", 0);
                StopSound("sounds/env_main.mp3", 0);
                StopSound("sounds/env_auto.mp3", 0);
                PlaySound("sounds/env_main.mp3", 1);
                
                videoBatmobile++;
                // console.log('videoBatmobile', videoBatmobile);
                if (videoBatmobile == 1) {
                    playVideo('video_gordon');
                    ObjSet('spr_video_play', { input: 0, alp: 0 });
                    showDialog();
                } else if (videoBatmobile == 2) {
                    playVideo('spr_video_bg_laboratory');
                    ObjSet('spr_video_play', { input: 0, alp: 0 });
                    showDialog();
                } else if (videoBatmobile == 3) {
                    playVideo('video_gordon');
                    ObjSet('spr_video_play', { input: 0 , alp: 0 });
                    showDialog();
                } else if (videoBatmobile == 4) {
                    playVideo('spr_video_bg_store');
                    ObjSet('spr_video_play', { input: 0, alp: 0 });
                    showDialog();
                } else if (videoBatmobile == 5) {  
                    playVideo('video_gordon');
                    ObjSet('spr_video_play', { input: 0 , alp: 0 });
                    showDialog();
                } else if (videoBatmobile == 6) {
                    playVideo('spr_video_bg_club');
                    ObjSet('spr_video_play', { input: 0 , alp: 0 });
                    showDialog();
                } else if (videoBatmobile == 7) {
                    playVideo('video_gordon');
                    ObjSet('spr_video_play', { input: 0 , alp: 0 });
                    showDialog();
                }
            } else if (currentVideo == 'video_gordon') {
                videoGordon++;
                if (videoGordon == 1) {
                    showDialog();
                } else if (videoGordon == 2) {
                    showDialog();
                }
            }
        }
    });

    var singleVideo = [
        'video_alfred',
        'video_alfred_surprised',
        'video_batman_menu',
        'video_batman_roof',
        'video_batmobile',
        'video_bruce_wayne',
        'video_bruce_wayne_after_sex',
        'video_gordon',
        'video_harley_quinn',
        'video_poison_ivy',
        'video_red_claw',
        'spr_video_bg_manor',
        'spr_video_bg_club',
        'spr_video_bg_laboratory',
        'spr_video_bg_store'
    ];

    playVideo = function (name) {
        StopSound("sounds/env_sex.mp3", 0);
        StopSound("sounds/env_dangerous.mp3", 0);
        PlaySound("sounds/env_main.mp3", 1);

        if (name == 'video_batmobile') {
            StopSound("sounds/env_sex.mp3", 0);
            StopSound("sounds/env_dangerous.mp3", 0);
            StopSound("sounds/env_main.mp3", 0);
            PlaySound("sounds/env_auto.mp3", 1);
            PlaySound("sounds/env_main.mp3", 1);
        }
        
        if (currentDialog == 30) {
            ObjSet('spr_video_play', { input: 0, alp: 0 });
        }

        currentVideo = name;
        singleVideo.forEach(function(nameVideo) {
            ObjSet(nameVideo, { alp: 0 });

            var vid = document.getElementById(nameVideo); 
            if (vid && vid.play) {
                vid.currentTime = 0;
                vid.playbackRate = 1;
                vid.loop = true;
                vid.pause();
                vid.oncanplay = function() {
                };
            }
        });
        ObjSet(name, { alp: 1 });

        var vid = document.getElementById(name); 
        if (vid && vid.play) {
            vid.currentTime = 0;
            vid.playbackRate = 1;
            vid.loop = true;
            // vid.play();
            vid.oncanplay = function() {
                vid.play();
                setLoading(0);
            };
        }
        SwitchRoom('room_video');
    }

    /* ******************** room bottle ******************** */
    // ObjAnimate('spr_bottle_speed_classic', 'scale_x', 1, 1, function() { }, [ 0,0,0.7, 0.6,0,0.9, 1.5,0,0.7 ]);
    // ObjAnimate('spr_bottle_speed_classic', 'scale_y', 1, 1, function() { }, [ 0,0,0.7, 0.6,0,0.9, 1.5,0,0.7 ]);

    startSexScene = function(vid) {
        PlaySound("sounds/env_sex.mp3", 1);
        StopSound("sounds/env_dangerous.mp3", 0);
        StopSound("sounds/env_main.mp3", 0);
        nameVideo = vid;
        doneSpeeds = [];
        video.src = "./video/" + nameVideo + "_stop.mp4";
        playSexVideo();
        isVideoCum = false;

        ObjSet('spr_bottle_play', { input: 1, alp: 1 });
        hideInterfaceSexScene();

        SwitchRoom('room_bottle');
    }

    function playSexVideo() {
        setLoading(1);
        video.currentTime = 0;
        video.playbackRate = 1;
        video.loop = true;
        // video.play();
        video.oncanplay = function() {
            video.play();
            setLoading(0);
        };
    }

    ObjSet('spr_bottle_play', { 
        event_mup: function() {
            video.src = "./video/" + nameVideo + "_slow.mp4";
            playSexVideo();
            startTimerSpeed();
        }
     });

    function hideInterfaceSexScene() {
        ObjSet('spr_bottle_slow', { input: 0, alp: 0 });
        ObjSet('spr_bottle_fast', { input: 0, alp: 0 });
        ObjSet('spr_bottle_furious', { input: 0, alp: 0 });
        ObjSet('spr_bottle_sperm_hub', { alp: 0 });
        ObjSet('spr_bottle_pleasure', { alp: 0 });
    }

    function showInterfaceSexScene() {
        ObjSet('spr_bottle_sperm_hub', { alp: 1 });
        ObjSet('spr_bottle_pleasure', { alp: 0.5 });
        ObjSet('spr_bottle_slow', { input: 1, alp: 0.5 });
        ObjSet('spr_bottle_fast', { input: 1, alp: 0.5 });
        ObjSet('spr_bottle_furious', { input: 1, alp: 0.5 });
    }
    
    function startTimerSpeed() {
        clearTimeout(timer);
        needSpeedVideo = '';

        ObjSet('spr_bottle_play', { input: 0, alp: 0 });
        showInterfaceSexScene();

        // win
        if (doneSpeeds.length >= 3) {
            setSpeedVideo('furious');

            // ObjSet('spr_bottle_cum', { input: 1, alp: 1, pos_x: 4, pos_y: 48 });
            ObjSet('spr_bottle_cum', { input: 1, alp: 1});

            // if (dialogCursor >= 108 && dialogCursor <= 110) {
            //     ObjSet('spr_bottle_cum', { res: './images/play.gif', pos_x: 22, pos_y: 82 });
            // } else {
            //     ObjSet('spr_bottle_cum', { res: './images/cum.png' });                
            // }
        } else {
            timer = setTimeout(function () {
                ObjSet('spr_bottle_slow', { input: 1, alp: 0.5 });
                ObjSet('spr_bottle_fast', { input: 1, alp: 0.5 });
                ObjSet('spr_bottle_furious', { input: 1, alp: 0.5 });

                clearTimeout(timer);
                var idVideo = randomInteger(1, 2);
                needSpeed = availSpeeds[idVideo];
                availSpeeds.splice(idVideo, 1);
                // console.log('needSpeed ', needSpeed);
                showNeedSpeedVideo(needSpeed);
            }, 2000);
        }
    }

    // currentDialog = 45;
    ObjSet('spr_bottle_cum', {
        event_mup: function() {
            // console.log('dialogCursor = ', dialogCursor);

            hideInterfaceSexScene();

            ObjSet('spr_bottle_slow', { input: 0 });
            ObjSet('spr_bottle_fast', { input: 0 });
            ObjSet('spr_bottle_furious', { input: 0 });

            PlaySound("sounds/sfx_sound_penis.mp3", 0);
            ObjSet('spr_bottle_cum', { input: 0, alp: 0 } );

            video.src = "./video/" + nameVideo + "_cum.mp4";
            setLoading(1);
            isVideoCum = true;
            video.currentTime = 0;
            video.playbackRate = 1;
            video.loop = false;
            // video.play();
            video.oncanplay = function() {
                video.play();
                setLoading(0);
            };

            video.onended = function() {
                if (!isVideoCum) return;

                // console.log('video.ended nameVideo', nameVideo);

                if (nameVideo == 'bruce_wayne') {
                    playVideo('video_bruce_wayne_after_sex');
                    showDialog();
                } else if (nameVideo == 'alfred') {
                    playVideo('video_batman_roof');
                    showDialog();
                } else if (nameVideo == 'poison_ivy') {
                    playVideo('video_batman_roof');
                    ObjSet('spr_video_chapter1', { alp: 1, input: 0 });
                    ObjSet('spr_video_chapter3', { alp: 1, input: 0 });

                    ObjSet('spr_video_chapter2', { alp: 1, input: 1, 
                        event_mup: function() {
                            playVideo('video_batmobile');
                            ObjSet('spr_video_play', { input: 1 , alp: 1 });
                            ObjSet('spr_video_chapter1', { input: 0, alp: 0 });
                            ObjSet('spr_video_chapter2', { input: 0, alp: 0 });
                            ObjSet('spr_video_chapter3', { input: 0, alp: 0 });
                        }
                    });
                } else if (nameVideo == 'red_claw') {
                    playVideo('video_batman_roof');
                    ObjSet('spr_video_chapter1', { alp: 1, input: 0 });
                    ObjSet('spr_video_chapter2', { alp: 1, input: 0 });

                    ObjSet('spr_video_chapter3', { alp: 1, input: 1, 
                        event_mup: function() {
                            playVideo('video_batmobile');
                            ObjSet('spr_video_play', { input: 1 , alp: 1 });

                            ObjSet('spr_video_chapter1', { input: 0, alp: 0 });
                            ObjSet('spr_video_chapter2', { input: 0, alp: 0 });
                            ObjSet('spr_video_chapter3', { input: 0, alp: 0 });
                        }
                    });
                } else if (nameVideo == 'harley_quinn') {
                    playVideo('video_batman_roof');
                    showDialog();
                }

                // *********** Обнуление параметров секс сцены *********** //
                video.pause();
                video.currentTime = 0;
                video.oncanplay = function() {
                };

                currentSpeedVideo = 'slow';
                isVideoCum = false;
                doneSpeeds = [];
                isChangeSpeed = false;
                nameVideo = '';
                availSpeeds = ['slow', 'fast', 'furious'];

                ObjStopAnimate('spr_bottle_sperm', 'pos_y');
                ObjSet('spr_bottle_sperm', { pos_y: 18 } );
            };
        },
        event_menter: function() {
            ObjSet('spr_bottle_cum', { scale_x: 1.5, scale_y: 1.5 });
        },
        event_mleave: function() {
            ObjSet('spr_bottle_cum', { scale_x: 1.3, scale_y: 1.3 });
        }
    });

    function showNeedSpeedVideo(needSpeed) {
        if (!needSpeed) {
            var idVideo = randomInteger(0, availSpeeds.length - 1);
            needSpeed = availSpeeds[idVideo];
            availSpeeds.splice(idVideo, 1);
        }
        needSpeedVideo = needSpeed;

        if (position == 'rider') {
            ObjSet('spr_bottle_speed_rider', { alp: 0.5 });
        } else if (position == 'doggy') {
            ObjSet('spr_bottle_speed_doggy', { alp: 0.5 });
        } else if (position == 'classic') {
            ObjSet('spr_bottle_speed_classic', { alp: 0.5 });
        } else if (position == 'sofa') {
            ObjSet('spr_bottle_speed_sofa', { alp: 0.5 });
        }
        ObjSet('spr_bottle_speed_' + position, { res: './images/' + needSpeedVideo + '.gif' });

        if (needSpeedVideo == currentSpeedVideo) {
            setSpeedVideo(needSpeedVideo);
        }
    }

    function setSpeedVideo(speedVideo) {
        if (!isChangeSpeed) {
            video.src = "./video/" + nameVideo + "_slow.mp4";
            setLoading(1);
            // video.play();
            video.oncanplay = function() {
                video.play();
                setLoading(0);
            };
            isChangeSpeed = true;
        }
        
        PlaySound("sounds/sfx_sound_penis.mp3", 0);
        var percent = 0;
        currentSpeedVideo = speedVideo;

        if (currentSpeedVideo == 'slow') {
            video.playbackRate = 1;
        } else if (currentSpeedVideo == 'fast') {
            video.playbackRate = 2;
        } else if (currentSpeedVideo == 'furious') {
            video.playbackRate = 2.5;
        }

        if (needSpeedVideo == currentSpeedVideo) {
            percent = ( (doneSpeeds.length + 1) * 33 );
        } else {
            percent = doneSpeeds.length * 33;
        }
        percent++;

        ObjAnimate('spr_bottle_sperm', 'pos_y', 0, 0, function() { 
            if (needSpeedVideo == currentSpeedVideo) {
                doneSpeeds.push(currentSpeedVideo);
                startTimerSpeed();
                ObjSet('spr_bottle_speed_' + position, { alp: 0 });
            }
        }, [ 0,0,ObjGet('spr_bottle_sperm').pos_y, 7,0,18-(percent*1.75) ]);
    }

    ObjSet('spr_bottle_slow', {
        event_mup: function() {
            setSpeedVideo('slow');
        },
        event_menter: function() {
            ObjSet('spr_bottle_slow', { scale_x: 0.45, scale_y: 0.45, alp: 0.5 });
        },
        event_mleave: function() {
            ObjSet('spr_bottle_slow', { scale_x: 0.4, scale_y: 0.4, alp: 0.5 });
        }
    });

    ObjSet('spr_bottle_fast', {
        event_mup: function() {
            setSpeedVideo('fast');
        },
        event_menter: function() {
            ObjSet('spr_bottle_fast', { scale_x: 0.45, scale_y: 0.45, alp: 0.5 });
        },
        event_mleave: function() {
            ObjSet('spr_bottle_fast', { scale_x: 0.4, scale_y: 0.4, alp: 0.5 });
        }
    });

    ObjSet('spr_bottle_furious', {
        event_mup: function() {
            setSpeedVideo('furious');
        },
        event_menter: function() {
            ObjSet('spr_bottle_furious', { scale_x: 0.45, scale_y: 0.45, alp: 0.5 });
        },
        event_mleave: function() {
            ObjSet('spr_bottle_furious', { scale_x: 0.4, scale_y: 0.4, alp: 0.5 });
        }
    });

    /* ******************** Анимация экрана окончания игры ******************** */
    animationEndGame = function(room) {
        ObjSet('spr_' + room + '_again', { input: 0, alp: 0 });
        ObjSet('spr_' + room + '_more_girls', { input: 0, alp: 0 });
        ObjSet('spr_' + room + '_title', { input: 0, alp: 0 });

        ObjAnimate('spr_' + room + '_title', 'scale_x', 0, 0, function() { }, [ 0,0,0.2, 0.6,0,2 ]);
        ObjAnimate('spr_' + room + '_title', 'scale_y', 0, 0, function() {

            ObjAnimate('spr_' + room + '_again', 'scale_x', 0, 0, function() { }, [ 0,0,0.2, 0.6,0,1.8 ]);
            ObjAnimate('spr_' + room + '_again', 'scale_y', 0, 0, function() {

                ObjAnimate('spr_' + room + '_more_girls', 'scale_x', 0, 0, function() { }, [ 0,0,0.2, 0.6,0,1.8 ]);
                ObjAnimate('spr_' + room + '_more_girls', 'scale_y', 0, 0, function() {
                    ObjSet('spr_' + room + '_again', { input: 1 });
                    ObjSet('spr_' + room + '_more_girls', { input: 1 });
                }, [ 0,0,0.2, 0.6,0,1.8 ]);
                ObjAnimate('spr_' + room + '_more_girls', 'alp', 0, 0, function() { }, [ 0,0,0, 0.2,0,0.8 ]);

            }, [ 0,0,0.2, 0.6,0,1.8 ]);
            ObjAnimate('spr_' + room + '_again', 'alp', 0, 0, function() { }, [ 0,0,0, 0.2,0,0.8 ]);

        }, [ 0,0,0.2, 0.6,0,2 ]);
        ObjAnimate('spr_' + room + '_title', 'alp', 0, 0, function() { }, [ 0,0,0, 0.2,0,1 ]);
    }

    /* ******************** Экран победителя ******************** */
    winGame = function () {
        ObjSet('spr_interface_full_screen', { input: 0, alp: 0 });
        StopSound("sounds/env_sex.mp3", 0);
        StopSound("sounds/env_dangerous.mp3", 0);
        StopSound("sounds/env_main.mp3", 0);
        StopSound("sounds/env_auto.mp3", 0);

        SwitchRoom("room_win");
        animationEndGame('win');
    }

    ObjSet('spr_win_again', { 
        event_mup: function() {
            PlaySound("sounds/sfx_sound_penis.mp3", 0);
            window.location.reload()
        },
        event_menter: function() {
            ObjSet('spr_win_again', { scale_x: 2, scale_y: 2 });
            PlaySound("sounds/sfx_sound_penis.mp3", 0);
        },
        event_mleave: function() {
            ObjSet('spr_win_again', { scale_x: 1.8, scale_y: 1.8 });
        }
    });

    ObjSet('spr_win_more_girls', { 
        event_mup: function() {
            PlaySound("sounds/sfx_sound_penis.mp3", 0);
            window.open('http://www.porngames.com/');
        },
        event_menter: function() {
            ObjSet('spr_win_more_girls', { scale_x: 2, scale_y: 2 });
            PlaySound("sounds/sfx_sound_penis.mp3", 0);
        },
        event_mleave: function() {
            ObjSet('spr_win_more_girls', { scale_x: 1.8, scale_y: 1.8 });
        }
    });

    /* ******************** Экран проигравшего ******************** */
    gameOver = function () {
        SwitchRoom("room_gameover");
        animationEndGame('gameover');
    }

    ObjSet('spr_gameover_again', { 
        event_mup: function() {
            PlaySound("sounds/sfx_sound_penis.mp3", 0);
            window.location.reload()
        },
        event_menter: function() {
            ObjSet('spr_gameover_again', { scale_x: 1, scale_y: 1 });
            PlaySound("sounds/sfx_sound_penis.mp3", 0);
        },
        event_mleave: function() {
            ObjSet('spr_gameover_again', { scale_x: 0.8, scale_y: 0.8 });
        }
    });

    ObjSet('spr_gameover_more_girls', { 
        event_mup: function() {
            PlaySound("sounds/sfx_sound_penis.mp3", 0);
            window.open('http://www.porngames.com/');
        },
        event_menter: function() {
            ObjSet('spr_gameover_more_girls', { scale_x: 1, scale_y: 1 });
            PlaySound("sounds/sfx_sound_penis.mp3", 0);
        },
        event_mleave: function() {
            ObjSet('spr_gameover_more_girls', { scale_x: 0.8, scale_y: 0.8 });
        }
    });

    /* ******************** Комната ******************** */
    SwitchRoom('room_preloader');

    // SwitchRoom('room_afterpreloader');
    // SwitchRoom('room_intro');

    //SwitchRoom('room_1room');
    // SwitchRoom('room_2room');
    // SwitchRoom('room_3room');
    // SwitchRoom('room_4room');
    // SwitchRoom('room_5room');
    // SwitchRoom('room_6room');
    // SwitchRoom('room_7room');

    // SwitchRoom('room_video');
    // SwitchRoom('room_bottle');
    // startSexScene('1');

    // playVideo('video_batman_menu');
    // playVideo('spr_video_bg_manor');

    // SwitchRoom('room_win');
    // SwitchRoom('room_gameover');
    // winGame();
    // gameOver();
};